<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: archive
 *
 * Description:
 *   WEB interface to make a study obsolete in the archive.
 *
 * Parameters:
 *
 *  @param cDevStudy   Device Id + ' ' + Study (multivalue, Device Id and Study Instance UID are concatenated by space)
 *                        Device Id is the Id of the archive device where the study is archived
 *                        Study is the Study Instance UID of the study to be retrieved from the Archive
 *  @param cConfirm    true means setting the study obsolete has been confirmed, do the real work
 *  @param cBack       Back URL (fallbacks: HTTP_REFERER, /archive/index.jsp)
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
-- %><%@page import="imagemed.util.Button"%>
<%@page import="imagemed.util.MessageBox"%>
<%@page import="imagemed.util.Helper"%>
<%@page import="java.text.Format"%>
<%@page import="imagemed.util.LocalizedMessage"%>
<%@page import="imagemed.dcprocessing.StudyRemover"%>
<%@page import="imagemed.taskd.IMScriptContext"%>
<%@
	page import="java.io.IOException, java.sql.SQLException, java.util.*,
			imagemed.dotcom.*, imagemed.exception.*, imagemed.imsession.*, imagemed.jsputil.*,
			com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			com.erad.pacs.common.interfaces.result.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!/**
	 * Sets studies obsolete on a non CWL server.
	 * Elements in the argument array are expected to be
	 * device IDs and study uids separated by a single space.
	 * The device ID is the ID of the server the archive resides on.
	 *
	 * @param context    task context for creating child tasks
	 * @param devStudy   array of studies 
	 * @param user       ID of the user initiated obsoletion
	 */
	void obsoleteStudies(IMScriptContext context, String[] devStudy, String user) {

		for (int i = 0; i < devStudy.length; i++) {
			int pos = devStudy[i].indexOf(' ');
			if (pos == -1)
				continue;

			String study = devStudy[i].substring(pos + 1);
			StudyRemover.obsoleteStudy( context, study, null, user );
		}
	}

	/**
	 * Sets studies obsolete on the child server(s).
	 * This method is expected to be used on CWL servers only.
	 *
	 * Elements in the argument array are expected to be
	 * device IDs and study uids separated by a single space.
	 * The device ID is the ID of the server the archive resides on.
	 *
	 * @param context    task context for creating child tasks
	 * @param devStudy array of studies 
	 * @param user     ID of the user initiated obsoletion
	 *
	 * @throws IOException if an I/O error occurs
	 * @throws SQLException if a SQL error occurs
	 * @throws IMException if any other error occurs
	 */
	void obsoleteStudiesOnChildServers(IMScriptContext context, String[] devStudy, String user) throws IOException, SQLException, IMException {
		// maps device IDs to study vector
		Hashtable<String,Vector<String>> ds = new Hashtable<String,Vector<String>>();

		// Sort out studies by peer (child devices)
		for (int i = 0; i < devStudy.length; i++) {
			int pos = devStudy[i].indexOf(' ');
			if (pos == -1)
				continue;

			String device = devStudy[i].substring(0, pos);

			String peerDev = DotcomConfig.getConfig().getServerNameTowards(device);
			if (peerDev == null)
				throw new IMException( LocalizedMessage.getCompoundMessage( "EXCEPTION_ARCHIVE_OBS_ROUTE_NOT_FOUND", new Format[] { null }, new Object[] { device }, false ) );

			Vector<String> v = ds.get(peerDev);
			if (v == null) {
				v = new Vector<String>();
				ds.put(peerDev, v);
			}
			v.add(devStudy[i]);
		}

		Properties rqheaders = new Properties();
		context.addJobContextTo( rqheaders );
		
		// Call peer devices to set studies obsolete

		for (Enumeration<String> e = ds.keys(); e.hasMoreElements(); ) {
			String peerDev = e.nextElement();
			Vector<String> studies = ds.get(peerDev);

			StringBuffer postData = new StringBuffer();
			if (user != null)
				postData.append("&cRegID=").append(Helper.URLEncodeUTF8(user));

			for (Iterator<String> iter = studies.iterator(); iter.hasNext(); ) {
				postData.append("&cDevStudy=").append(Helper.URLEncodeUTF8(iter.next()));
			}

			postData.setCharAt(0, '?');
			
			String response = Dotcom.getHttpPage(peerDev, "/archive/obs.jsp", postData.toString(), rqheaders, null);
			if (response == null || response.indexOf("RESULT: OK") == -1) {
				throw new IMException( LocalizedMessage.getCompoundMessage( "EXCEPTION_ARCHIVE_OBS_ERROR_OBSOLETING", new Format[] { null }, new Object[] { peerDev }, false ) );
			}
		}
	}

%><%

	IMSession is = new IMSession(request, response, out);

	boolean isFromCWLParent = false;
	try {
		// Check if peer is a CWL parent server
		Properties remotePrp = DotcomToolbox.checkClient(is, "P");
		String id = remotePrp.getProperty("ID");

		DotcomDevice selfDevice = DotcomConfig.selfDevice();
		if (selfDevice.isParent(id) && DotcomConfig.isParentDbOnly()) {
			// The request was received from CWL parent server
			isFromCWLParent = true;
		}
	}
	catch(Throwable th) {
	}

	if (isFromCWLParent) {
		String[] parDevStudy = request.getParameterValues("cDevStudy");
		if ( null == parDevStudy || parDevStudy.length == 0) {
			out.println("RESULT: FAILED");
			return;
		}

		IMScriptContext context = IMScriptContext.readJobContextFrom( request );
		obsoleteStudies( context, parDevStudy, is.regID );
		out.println("RESULT: OK");
		return;
	}

	// Regular request from user
	
	if (!is.regOK(false)) {
		return;
	}

	if (-1 == is.regRights.indexOf('A')) {
		throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "EXCEPTION_ARCHIVE_NO_PERMISSION" ), "archive/index.jsp", LocalizedMessage.getSimpleMessage( "NO_RIGHTS" ), null);
	}


	String backURL = request.getParameter("cBack");
	if (backURL == null) {
		backURL = request.getHeader("REFERER");
	}
	if (backURL == null) {
		backURL = "/archive/index.jsp";
	}

	String[] parDevStudy = request.getParameterValues("cDevStudy");
	boolean isConfirmed = "true".equals(request.getParameter("cConfirm"));

	if (parDevStudy == null || parDevStudy.length == 0) {
		throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "EXCEPTION_ARCHIVE_OBS_ONE_STUDY" ) , "archive/index.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_MISSING_PARAMETER" ), backURL);
	}

	String pStudy = parDevStudy.length > 1 ? "studies" : "study";
	
	String titleMsg = parDevStudy.length > 1 ? LocalizedMessage.getSimpleMessage( "ARCHIVE_OBS_SET_STUDY_OBSOLETE_IN_ARCHIVE_PLURAL" ) : LocalizedMessage.getSimpleMessage( "ARCHIVE_OBS_SET_STUDY_OBSOLETE_IN_ARCHIVE" ); 

%><HTML><HEAD><TITLE><%= titleMsg %></TITLE>
<%
	if (isConfirmed) {
		IMScriptContext context = new IMScriptContext();
		
		DotcomDevice selfDevice = DotcomConfig.selfDevice();
		if (selfDevice.isDbOnly()) {
			try {
				obsoleteStudiesOnChildServers(context, parDevStudy, is.regID);
			}
			catch (Throwable th) {
				String msg = th.getMessage();
				if (msg != null)
					msg = "<BR><BR>" + Helper.htmlEncode(msg);
				else
					msg = "";
				
				String errorMsg = parDevStudy.length > 1 ? LocalizedMessage.getSimpleMessage( "EXCEPTION_ARCHIVE_ERROR_OBSOLETING_PLURAL" ) : LocalizedMessage.getSimpleMessage( "EXCEPTION_ARCHIVE_ERROR_OBSOLETING" );
				throw new IMGeneralException(errorMsg + msg, "archive/index.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_ERROR_TITLE" ), backURL);
			}
		}
		else {
			obsoleteStudies( context, parDevStudy, is.regID );
		}
%>
 <META http-equiv="Refresh" content="3; URL=<%= backURL %>">
<%
		imagemed.http.tabs.TabBean.writeStyleOnly(is);
		TabToolbox.writeIMpopup(out);
%>
 </HEAD>
 <BODY>
 <CENTER><BR>
<%
		TabToolbox.makeTabs( is, is.tabbean, "archive/index.jsp", "White");
%>
 <h3><%=  parDevStudy.length > 1 ? LocalizedMessage.getSimpleMessage( "ARCHIVE_OBS_STUDY_OBSOLETE_PLURAL" ) : LocalizedMessage.getSimpleMessage( "ARCHIVE_OBS_STUDY_OBSOLETE" ) %></h3>
 </center></body></html>
<%
	return;
	} // END isConfirmed


	// Print Confirm page

	String filterStudies = "";
	for (int i = 0; i < parDevStudy.length; i++) {
		int pos = parDevStudy[i].indexOf(' ');
		if ( pos == -1 ) {
			continue;
		}
		filterStudies = filterStudies + ";" + parDevStudy[i].substring(pos + 1);
	}

	Properties filters = new Properties();
	filters.setProperty("SYUI", filterStudies.substring(1));

	String fields[] = TableParamsImpl.getDefaultFields("/archive/index.jsp", is);

	TableDescriptorImpl tdesc = new TableDescriptorImpl("archive/index.jsp");
	TablePropertiesImpl tprop = new TablePropertiesImpl();

	TableParamsImpl tparams = new TableParamsImpl(is.imRequest);
	tparams.setDefaultFields(fields);
	tparams.setDefaultFilters(filters);

	tdesc.setTableParams(tparams);
	tdesc.setTableProperties(tprop);
	tdesc.setFieldManager( new ArchivesFieldManagerImpl( ArchivesFieldManagerImpl.MODE.EP_ARCHIVES, ArchivesFieldManagerImpl.ISSUER.LOCAL ) );

	ArchivesResultImpl result = new ArchivesResultImpl(tdesc, null);
	tdesc.setResult(result);
	TableImpl table = new TableImpl(tdesc);

	TabToolbox.writeIMpopup(out);
	table.printScript(tparams, is);
%>
</HEAD>
<BODY>
<CENTER>
<%
	TabToolbox.makeTabs( is, is.tabbean, "archive/index.jsp", "White");
%><table border=1 cellpadding=0 cellspacing=0 width="100%">
<tr class=BgShadow>
<td width="100%"><br><table border=0 width="100%" ><tr>

<td width="50%">&nbsp;&nbsp;<font size=4><%= LocalizedMessage.getSimpleMessage( "ARCHIVE_OBS_OBSOLETE_STUDIES" ) %></font></td>

</tr></table><br></td></tr></table>
<%

	table.printTableWithoutPageNavigation(is, null, false);

%>
	<FORM NAME="confirmForm" ACTION="/archive/obs.jsp" METHOD=POST>
	<INPUT TYPE="HIDDEN" NAME="cBack" VALUE="<%= Helper.htmlEncode(backURL) %>">
	<INPUT TYPE="HIDDEN" NAME="cConfirm" VALUE="true">
<%
	for (int i = 0; i < parDevStudy.length; i++) {
%>
	<INPUT TYPE="HIDDEN" NAME="cDevStudy" VALUE="<%= Helper.htmlEncode(parDevStudy[i]) %>">
<%
	}
%>
	</FORM>
<%

	String setStudyPlural = LocalizedMessage.getSimpleMessage( "ARCHIVE_OBS_SET_STUDY_OBSOLETE_PLURAL" );
	String setStudy = LocalizedMessage.getSimpleMessage( "ARCHIVE_OBS_SET_STUDY_OBSOLETE" );
	String setStudyMsgPlural = LocalizedMessage.getSimpleMessage( "ARCHIVE_OBS_SET_STUDY_OBSOLETE_MSG_PLURAL" );
	String setStudyMsg = LocalizedMessage.getSimpleMessage( "ARCHIVE_OBS_SET_STUDY_OBSOLETE_MSG" );
	
	MessageBox mb = new MessageBox(parDevStudy.length > 1 ? setStudyPlural : setStudy, "50%");
	mb.setMessage("<TABLE><TR><TD><H3>&nbsp;&nbsp;" + ( parDevStudy.length > 1 ? setStudyMsgPlural : setStudyMsg ) + ".<BR></TD></TR></TABLE>");
	mb.addButton(new Button("javascript:self.document.confirmForm.submit();", "BUTTON_OK", (parDevStudy.length > 1 ? "ARCHIVE_OBS_SET_STUDY_OBSOLETE_PLURAL" : "ARCHIVE_OBS_SET_STUDY_OBSOLETE" )));
	mb.addButton(new Button(backURL, "BUTTON_CANCEL", ( parDevStudy.length > 1 ? "ARCHIVE_OBS_DONT_SET_STUDY_OBSOLETE_PLURAL" : "ARCHIVE_OBS_DONT_SET_STUDY_OBSOLETE" )));
	mb.print(is.out);

%>
</CENTER></BODY></HTML>
--%>