#!/bin/sh
#
# Component: archive
#
# Description:
#  schedules merge tasks if the queue is small enough.
#
# Usage:
#   scheduleMerge.sh
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh
if [ ! -f "$ARCHIVE_VAR/archive.cfg" ] ; then
	exit 1
fi

. "$ARCHIVE_VAR/archive.cfg"
if [ "$Archive" != "readonly" -o "$DoMerge" != "true" ] ; then
	exit 1
fi

listFile="$VAR/Archive_merge.lst"
if [ ! -f "$listFile" ] ; then
	echo "select distinct STYIUID from $ARCHIVETBL order by THEDATETIME DESC;" |$MYSQL_HOME/bin/mysql -N $DBNAME | grep -v "^STYIUID$"> $listFile
fi

# check the size of the QUEUE not scheduled and scheduled
#
# TODO: Might be rewritten for 6.3
#
tasknum=`ls -1 ${TASKD_GLOBALQUEUE} ${TASKD_GLOBALQUEUE}/.scheduled| wc -l`
[ $tasknum -ge 1000 ] && exit 0
echo "scheduling 500 studies"
# if it is below 1000 schedule 500 merge.sh (maybe the latest 500 studies, puts some references or some
# other way indicates that the merge has been started for this studies...
GREPVFILE="$TMP/grepv.$$"
for study in `head --lines=500 $listFile` ; do
	echo "^$study$" >> $GREPVFILE
	
	$TASKD_HOME/createtaskfileapp -p MERGE_ARCHIVE_STUDY -t "class" -c "archive.Get -m $study"
done
grep -v -f $GREPVFILE $listFile > ${listFile}.new
rm $listFile
mv ${listFile}.new $listFile
rm -f $GREPVFILE 2>/dev/null
