<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *    Performs daily tasks: purges old studies and orders.
 *
 * Last Updated     : $Author: tnemeth $
 * Update Date Time : $Date: 2014/04/17 10:22:18 $
 * RCS File Name    : $RCSfile: daily.jsp,v $
 * RCS Revision     : $Revision: 1.14 $
 * Locked by        : $Locker:  $
 * Symbolic name    : $Name:  $
 * State            : $State: Exp $
-- %><%@
	page import="java.util.*, java.io.*, java.sql.*,
			imagemed.imsession.*, imagemed.util.*, imagemed.jsputil.StudyToolbox"

%><%!

	String getDateFromCalendar( Calendar cal ) {
		String strDate = "" + cal.get( Calendar.YEAR );
		strDate = strDate + Helper.getIntWithZeros( cal.get( Calendar.MONTH ) + 1,2 );
		strDate = strDate + Helper.getIntWithZeros( cal.get( Calendar.DAY_OF_MONTH ) , 2 );

		return strDate;
	}


	// get the date from relDays days AGO
	String getAbsoluteDate( String relDays ) {
		String retVal = null;

		try {
			if ( relDays.startsWith( "-" ) ) {
				// legacy "-xx days" format
				int pos = relDays.indexOf( ' ' );
				if ( pos != -1 )
					relDays = relDays.substring( 1, pos );
				else
					relDays = relDays.substring( 1 );
			}
			
			int num = Integer.parseInt( relDays );
			int nUnit = Calendar.DAY_OF_YEAR;

			GregorianCalendar cal = new GregorianCalendar();
			cal.add( nUnit, -num );

			retVal = getDateFromCalendar( cal );
		}
		catch ( Throwable th ) {
		}

		return retVal;
	}


	void purge( String relDays, int fromstatus, int tostatus, String datefield, Syslog s ) {
		String limitTime = getAbsoluteDate( relDays );

		if ( limitTime == null )
			return;

		s.syslog( Syslog.LOG_DEBUG, "Purge check: " + limitTime + " " + fromstatus + "-" + tostatus );
		try {
			String query = "select PNAME,MODALITY,MAINST,STYIUID," + datefield + " from " + IMEnvBase.getEnv( "STUDYTBL" ) +
					" where FOLDER='' and MAINST>=" + fromstatus + " and MAINST<=" + tostatus + " and " + datefield + " <'" + limitTime +  "'";

			s.syslog( Syslog.LOG_DEBUG, "Purge query: " + query );
			PreparedStatement ps = IMEnv.getDB().prepareStatement( query );
			ResultSet rs = ps.executeQuery();

			while ( rs.next() ) {
				String study = rs.getString( "STYIUID" );
				String pname = rs.getString( "PNAME" );
				// String date   = rs.getString(datefield);
				String mod = rs.getString( "MODALITY" );

				s.syslog( Syslog.LOG_DEBUG, "Purge study: " + study + " " + pname );

				try {
					if ( StudyToolbox.isOrder( study ) ) {
						// delete order on owner only
						StoreState storestate = new StoreState( study );
						storestate.load();
						boolean isOwner = "yes".equals( storestate.getAttribute( "StudyOwner" ) );
						if ( !isOwner ) {
							s.syslog( Syslog.LOG_DEBUG, "Skipping order owned by another server: " + study );
							continue;
						}
						
						s.syslog( Syslog.LOG_DEBUG, "Purge order: " + study + " " + pname );
						StudyToolbox.deleteOrder( study, "system" );
					}
					else {
						// Reference counters will take care of not removing unforwarded/unarchived files
						s.syslog( Syslog.LOG_DEBUG, "Purge study: " + study + " " + pname );
						imagemed.dcprocessing.StudyRemover.removeStudy( null, study, null, null, false );
					}

					OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "purge" );
					logEntry.setField( OperLogEntry.FIELD.USER, "system" );
					logEntry.setField( OperLogEntry.FIELD.STUDY, study );
					logEntry.setField( OperLogEntry.FIELD.PNAME, pname );
					logEntry.setField( OperLogEntry.FIELD.MODALITY, mod );
					logEntry.log( "daily.jsp", 0, Syslog.LOG_INFO );
				}
				catch ( Throwable th2 ) {
					Helper.ERRORLOG( "daily.jsp", "Exception when purging " + study + ": " + Helper.throwable2String( th2 ) );
				}
			}
			rs.close();
		}
		catch ( Throwable th ) {
			Helper.ERRORLOG( "daily.jsp", "Exception: " + Helper.throwable2String( th ) );
		}

	} // purge()


%><%
	new IMSession( request, response, out ); 

	Syslog s = new Syslog( "daily", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) ); 

	String requestIP = request.getRemoteAddr();
	String localIP = java.net.InetAddress.getLocalHost().getHostAddress();

	if ( !requestIP.equals( localIP ) ) {
		s.syslog( Syslog.LOG_INFO, "Invalid call from " + requestIP );
		return;
	}


	File dailyFile = new File( IMEnvBase.getEnv( "CONF" ) + "/daily.rec" );
	if ( !dailyFile.exists() ) {
		s.syslog( Syslog.LOG_INFO, "No daily task" );
		return;
	}

	s.syslog( Syslog.LOG_INFO, "Daily task processing started" );

	IMProperties dailyPrp = new IMProperties();
	dailyPrp.recRead( IMEnvBase.getEnv( "CONF" ) + "/daily.rec" );

	String mode = request.getParameter( "mode" );
	if ( mode == null )
		mode = "";

	if ( mode.indexOf( "|Purge|" ) != -1 ) {
		String purgeFinal = dailyPrp.getProperty( "PurgeFinal" );
		if ( purgeFinal == null )
			purgeFinal = dailyPrp.getProperty( "PurgeShort" ); // legacy name

		String purgeStudy = dailyPrp.getProperty( "PurgeStudy" );
		if ( purgeStudy == null )
			purgeStudy = dailyPrp.getProperty( "PurgeLong" ); // legacy name

		String purgeOrder = dailyPrp.getProperty( "PurgeOrder" );

		purge( purgeFinal, 80, 1000, "RCVDATETIME", s );
		purge( purgeStudy, 0, 79, "RCVDATETIME", s );
		purge( purgeOrder, -1000, -1, "THEDATETIME", s );
	}

	s.syslog( Syslog.LOG_INFO, "Daily task processing finished" );
%>
--%>