<%--
 * Component: cases
 *
 * Description:
 *  Interface for locking/unlocking studies used by the viewer and remote dotcom servers.
 *
 * Parameters:
 *
 *   cStudy        Study Instance UID
 *   cOp           Lock operation: Lock, Break, CheckLock, IsLocked, Unlock (= default), lockOwners, None
 *   cClose        true - indicates the study is being closed in the viewer
 *                    in case of cClose=true only Unlock and None are the valid lock operations
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%>
<%@page import="com.erad.pacs.modules.gwt.exception.LockException"%>
<%@page import="com.erad.pacs.modules.gwt.exception.usermanager.SessionException"%>
<%@page import="com.erad.pacs.modules.gwt.session.right.PacsRight"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.common.interfaces.AkacFacade"%>
<%@page import="com.erad.pacs.services.usermanager.tomcat.Sessita"%>
<%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,java.util.*,java.sql.*,imagemed.types.flag.IMTypeur"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%>
<%	Sessita sessita = Sessita.Create( request, response );
	Session sess = sessita.getSession();


	String parOp = request.getParameter( "cOp" );
	String parStudy = request.getParameter( "cStudy" );
	boolean isClose = "true".equals( request.getParameter( "cClose" ) );

	if ( parOp == null )
		parOp = "Unlock";

	Syslog logger = new Syslog( "lockstudy.jsp", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );
	logger.syslog( Syslog.LOG_DEBUG, parStudy + " " + sess.getSessionId(  ) );
	if ( null == parStudy ) {
		logger.syslog( Syslog.LOG_DEBUG, "Study is null" );
		response.setHeader( "IMLock", "FAILED" );
%>FAILED<%return;
	}

	/*
	is.bCheckHttpsAndRedirect = false;
	if ( ! ProxyToolbox.init( is, null, logger ) && ! is.regOK() ) {
		if ( "Unlock".equals( parOp ) ) {
			// Allow releasing locks for anyone - fail otherwise
			is.regRights = "R";
			if ( is.regID == null && is.prevUserID != null ) {
				// Pick up last valid user from session if any - for logging 
				is.regID = is.prevUserID;
				is.regGroup = "";
			}
		}
		else {
			// Fail otherwise
			logger.syslog( Syslog.LOG_DEBUG, "regOK failed" );
			return;
		}
	}
	*/
	
	// reg.jspi sets is.regID to null
//	if ( is.regID == null )
//		is.setRegID( request.getHeader( "IMRegID" ) );
//	if ( is.regID == null )
//		is.setRegID( request.getParameter( "cRegID" ) );

//	if ( request.getHeader( "IMLockID" ) == null && request.getParameter( "cIMLockID" ) != null ) {
//		if ( is.sessionVariables == null )
//			is.sessionVariables = new Properties();
//		is.sessionVariables.setProperty( "IMLockID", request.getParameter( "cIMLockID" ) );
//	}

	if ( isClose ) {
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "close" );
		logEntry.setField( OperLogEntry.FIELD.USER, sess.getUser().getUserId(  ) );
		logEntry.setField( OperLogEntry.FIELD.STUDY, parStudy );

		try ( ResultSet rs = IMEnv.getDB().prepareStatement( "select * from Dcstudy WHERE STYIUID='" + parStudy + "'" ).executeQuery() ) {
	if ( rs.next() ) {
		logEntry.setField( OperLogEntry.FIELD.PNAME, rs.getString( "PNAME" ) );
		logEntry.setField( OperLogEntry.FIELD.MODALITY, rs.getString( "MODALITY" ) );
		logEntry.setField( OperLogEntry.FIELD.PID, rs.getString( "PID" ) );
		logEntry.setField( OperLogEntry.FIELD.ACCNO, rs.getString( "ACCNO" ) );
		logEntry.setField( OperLogEntry.FIELD.STUDYDATE, rs.getString( "THEDATETIME" ) );
		logEntry.setField( OperLogEntry.FIELD.INSTITUTION, rs.getString( "INSTNAME" ) );
		logEntry.setField( OperLogEntry.FIELD.STUDYDESCR, rs.getString( "STYDESCR" ) );
	}
		}
		catch ( SQLException sqlEx ) {
			logger.syslog( Syslog.LOG_ERR, Helper.throwable2String( sqlEx ) );
		}
		logEntry.log( sess, "lockstudy", 0, Syslog.LOG_INFO );
	}

	if ( !sess.getRights().hasAnyOf( PacsRight.Report, PacsRight.SetStatus, PacsRight.Transcribe)) {
		logger.syslog( Syslog.LOG_DEBUG, "No Rights" );
		response.setHeader( "IMAuthentication", "norights" );
%>FAILED<%
	return;
	}

	if ( "Break".equals( parOp ) && !sess.getRights(  ).hasRight( PacsRight.BreakLock ) ) { 
		logger.syslog( Syslog.LOG_DEBUG, "No Break Rights" );
		response.setHeader( "IMAuthentication", "norights" );
%>FAILED<%
		return;
	}

	// in case of shortcuts the original study should be locked
	String sourceStudy = StudyToolbox.getSourceStudyDB( parStudy );
	
	if ( ProxyToolbox.checkAndProxy( sess, sourceStudy, false ) ) {
		logger.syslog( Syslog.LOG_DEBUG, "checkAndProxy is true" );
		return;
	}

	Properties rspHeaders = new Properties();
//	IMLock imLock = IMLock.createLocalStudyLock( parStudy, is );
//	String res = imLock.localLock( parOp, rspHeaders );
	for ( Enumeration<?> e = rspHeaders.propertyNames(); e.hasMoreElements(); ) {
		String name = ( String ) e.nextElement();
		response.setHeader( name, rspHeaders.getProperty( name ) );
	}

	if (parOp.compareTo( "Unlock" ) == 0) {
		try {
			AkacFacade.unlockStudy( sess, parStudy, IMLock.getLockIDFromRequest( sess, request, null ) );
		} 
		catch (LockException | SessionException le) {
			out.println( "FAILED" );
			return;
		}
	} else {
		out.println( "FAILED" );
		return;
	}


%>OK<%

	if ( true )
		return;
%>