<%--
 * Component: cases
 *
 * WEB interface for getting/sending/deleting/listing/overwriting reports templates.
 *
 * cOper : describes what to do: 
 *     read      : get a template
 *     list      : list available templates
 *     write     : put a template
 *     overwrite : put a template over an existing one
 *     delete    : delete a template
 *
 * cTemplate : name of the template to read/write/overwrite/delete (not needed for 'list')
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="imagemed.jsputil.CannedReportManager"%>
<%@page import="imagemed.jsputil.CannedReportManager.CannedReport"%>
<%@page import="com.erad.pacs.services.usermanager.tomcat.Sessita"%>
<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.imsession.*,imagemed.util.*,java.io.*, imagemed.jsputil.DotcomToolbox"

%><%!String getFileName(Session sess, String templateName) {
		return IMEnvBase.getEnv("USERS_DATA")+"/"+sess.getUser().getUserId()+"/report_templates/"+templateName+".tmplt";
	}%><%
	Sessita sessita = Sessita.Create( request, response );
	Session sess = sessita.getSession();
	
	response.setStatus(HttpServletResponse.SC_OK);

	File templatesDir = new File(IMEnvBase.getEnv("USERS_DATA")+"/"+sess.getUser().getUserId()+"/report_templates");
	if (!templatesDir.exists()) {
		templatesDir.mkdirs();
	}
	String parOper = request.getParameter("cOper");
	String parTemplate = request.getParameter("cTemplate");
	String parContent = request.getParameter("cContent");

	if (parOper == null || parOper.length() == 0) {
		response.setStatus(HttpServletResponse.SC_BAD_REQUEST);
		response.setHeader("Error", "Required parameter 'cOper' is missing!");
		return;
	}
	if (!"list".equals(parOper) && (parTemplate == null || parTemplate.length() == 0)) {
		response.setStatus(HttpServletResponse.SC_BAD_REQUEST);
		response.setHeader("Error", "Required parameter 'cTemplate' is missing!");
		return;
	}
	String fileName = getFileName(sess, parTemplate);
	File file = new File(fileName);
	if ("read".equals(parOper)) {
		if (!file.exists()) {
			response.setStatus(HttpServletResponse.SC_NOT_FOUND);
			response.setHeader("Error", "Template file \""+parTemplate+"\" for user \""+sess.getUser().getUserId()+"\" not found!");
			return;
		}
		response.setContentType("text/plain");
		String result = CannedReportManager.toLegacy( Helper.readTextFile(fileName) );
		response.setContentLength(result.length());
		out.print(result);
		return;
	}

	if ("list".equals(parOper)) {
		response.setContentType("text/plain");
		String[] fileNames = Helper.getDirectoryContentAsStringArray(templatesDir.getAbsolutePath(), "*.tmplt");
		if (fileNames == null) {
			response.setHeader("Error", "Could not create templates directory!");
			return;
		}
		for (int i=0; i<fileNames.length; i++) {
			out.println(fileNames[i].substring(0, fileNames[i].length()-6));
		}
		return;
	}
	if ("overwrite".equals(parOper)) {
		if (file.exists()) {
			file.delete();
		}
		parOper = "write";
	}
	if ("write".equals(parOper)) {
		if (file.exists()) {
			response.setStatus(HttpServletResponse.SC_CONFLICT);
			response.setHeader("Error", "Template file \""+parTemplate+"\" for user \""+sess.getUser().getUserId()+"\" already exists!");
			return;
		}
		if (parContent==null) {
			StringBuffer strBuf = new StringBuffer("");
			BufferedReader reader = new BufferedReader(new InputStreamReader(request.getInputStream()));
			String line = reader.readLine();
			while (line != null) {
				strBuf.append(line);
				line = reader.readLine();
				if (line != null) {
					strBuf.append("\n");
				}
				parContent = strBuf.toString();
			}	
		}
		if ("true".equals(request.getParameter("cFromBrowser"))) {
			CannedReportManager crm = new CannedReportManager( sess.getUser().getUserId(), false);
			CannedReport cr = crm.createTemplate( parTemplate, parContent );
			String[] modalities = request.getParameterValues( "cModality" );
			if (modalities != null && modalities.length > 0) {
				cr.setProperty( CannedReport.MODALITIES, modalities );
			}
			cr.save();
		}
		else {
			Helper.writeTextFile(fileName, parContent);
			DotcomToolbox.proliferateFile(fileName);
		}
		return;
	}
	if ("delete".equals(parOper)) {
		if (!file.exists()) {
			response.setStatus(HttpServletResponse.SC_NOT_FOUND);
			response.setHeader("Error", "Template file \""+parTemplate+"\" for user \""+sess.getUser().getUserId()+"\" not found!");
			return;
		}
		CannedReportManager.deleteTemplate( sess.getUser().getUserId(), parTemplate);
		return;
	}
	
	response.setStatus(HttpServletResponse.SC_BAD_REQUEST);
	response.setHeader("Error", "Unknown operation: "+parOper);

	if (true) {
		// For avoiding extra newline(s)
		return;
	}%>
