<%--
 * Component: cases
 *
 * Description:
 *    Updates the CacheState database table with the current loaded percent of studies on a workstation (viewer cache).
 *
 * Parameters:
 *    CacheInfo : cache information. Below is an example:
 *
 * *Example of input (CacheInfo)
 * Version PBS001
 * WorkstationID 193.68.54.149
 * StudyCount 3
 * StudyUID 999.999.3859744
 * StudyRate 50
 * StudyUID 1.2.840.113674.1115.261.200
 * StudyRate 100
 * StudyUID 1.2.840.113704.3.1.429231.343410.121952.38
 * StudyRate 33
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.tomcat.Sessita"%>
<%@
   page import="java.sql.*,imagemed.imsession.*,java.util.*,imagemed.exception.*,imagemed.util.*"

%><%!

	String getInput(HttpServletRequest request) throws Throwable {
		String parCacheInfo = request.getParameter("CacheInfo");
		if (parCacheInfo == null || "".equals(parCacheInfo))
			throw new Throwable("Epmty input Error");
		return parCacheInfo;
	}

//	String getWorkstationID(IMSession is) throws IMException {
//		String result = is.getClientID();
//		if (result == null) {
//			throw new IMException("no registered device");
//		}
//		return result;
//	}

	// position of next '\n' or '\r' (less of them)
	// except there are not next \n or \r => returns -1
	int nextEOL(String inputString, int posBegin) {
		int nextLF = inputString.indexOf('\n', posBegin);
		int nextCR = inputString.indexOf('\r', posBegin);

		if (-1 == nextLF && -1 == nextCR) {
			return -1;
		}
		if (-1 == nextLF) {
			nextLF = Integer.MAX_VALUE;
		}
		if (-1 == nextCR) {
			nextCR = Integer.MAX_VALUE;
		}
		return Math.min(nextLF, nextCR);
	}

	Map<String, Integer> getRateOfStudies(String inputString) throws Throwable {
		Map<String, Integer> result = new HashMap<String, Integer>();
		int posBegin = inputString.indexOf("StudyUID");
		if (posBegin == -1) {
			return result;
		}

		int posEnd = inputString.lastIndexOf("StudyRate");
		if (posEnd == -1) {
			throw new Throwable("End of info of studies not found Error");
		}
		posEnd = nextEOL(inputString, posEnd);

		String infoOfStudies = posEnd == -1 ? inputString.substring(posBegin) : inputString.substring(posBegin, posEnd);
		StringTokenizer stk = new StringTokenizer(infoOfStudies, "\r\n");

		while (stk.hasMoreTokens()) {
			String lineSTYIUID = stk.nextToken();
			if (!lineSTYIUID.startsWith("StudyUID ")) { // parse error => syncronize!
				while (stk.hasMoreTokens()) {
					if (stk.nextToken().startsWith("StudyRate")) {
						break;
					}
				}
				continue;
			}
			int sep = lineSTYIUID.indexOf(' ');
			String uid = lineSTYIUID.substring(sep + 1);

			if (!stk.hasMoreTokens()) {
				break; //parse error
			}
			String lineRate = stk.nextToken();
			if (lineRate.startsWith("StudyRate ")) {
				sep = lineRate.indexOf(' ');
				try {
					result.put(uid, new Integer( lineRate.substring( sep + 1 ) ) );
				}
				catch (NumberFormatException nfe) {
					// parse error
				}
			}
		}
		return result;
	}

%><%
	Sessita sessita = Sessita.Create( request, response );
	Session sess = sessita.getSession();

	String workstationID = null;
	
	Map<String, Integer> rateOfStudies = null;
	String cacheTable = IMEnvBase.getEnv("CACHETBL");
	if (cacheTable == null)
		cacheTable = "CacheState";

	response.getWriter(  ).println("OK");
	return;
	
//	try {
//		String inputString = getInput(request);
//	//	workstationID = getWorkstationID(sess);
//		Helper.DEBUG("updatecachestate.jsp", "workstationID="+workstationID);
//		if (workstationID == null || "".equals(workstationID)) {
//			throw new IMException("Empty workstation ID Error");
//		}
//		rateOfStudies = getRateOfStudies(inputString);
//		
//		// query current state
//		Connection imDB = IMEnv.getDB();
//		Statement prev = imDB.createStatement();
//		Set<String> removedStudies = new HashSet<String>();
//		ResultSet rs = prev.executeQuery("SELECT SRCSTUDY, LOADED FROM " + cacheTable + " WHERE WSID='" + workstationID + "'");
//		while (rs.next()) {
//			String study = rs.getString("SRCSTUDY");
//			if (!rateOfStudies.containsKey(study)) {
//				// removed from cache
//				removedStudies.add(study);
//			}
//			else {
//				Integer loaded = new Integer( rs.getInt("LOADED") );
//				if (loaded.equals(rateOfStudies.get(study))) {
//					// did not change
//					rateOfStudies.remove(study);
//				}
//			}
//		}
//		Statement del = imDB.createStatement();
//		int count = 0;
//		StringBuffer deleteClause = new StringBuffer("");
//		for (String study : removedStudies) {
//			if (count++ == 0) {
//				deleteClause = new StringBuffer(deleteClause.capacity());
//				deleteClause.append("DELETE FROM " + cacheTable + " WHERE WSID='" + workstationID + "' AND SRCSTUDY in (");
//			}
//			deleteClause.append("'"+study+"',");
//			if (count == 40) {
//				del.executeUpdate(deleteClause.substring(0, deleteClause.length()-1)+")");
//				count = 0;
//			}
//		}
//		if (count > 0) {
//			del.executeUpdate(deleteClause.substring(0, deleteClause.length()-1)+")");
//		}
//		
//		PreparedStatement repl = imDB.prepareStatement("REPLACE INTO " + cacheTable + " ( WSID, SRCSTUDY, LOADED ) VALUES ('" + workstationID + "',?,?)");
//		for (String uid : rateOfStudies.keySet()) {
//			repl.setString(1, uid);
//			Integer rate = rateOfStudies.get(uid);
//			repl.setInt(2, rate.intValue() );
//			repl.executeUpdate();
//		}
//	}
//	catch (Throwable t) {
//		is.out.println("FAILED - " + t.getMessage());
//	}
//
//	response.getWriter(  ).println("OK");
//
//	if (true) {
//		// For avoiding extra newline(s)
//		return;
//	}

%>