<%--
 * Component: download
 *
 * Description:
 *     Retrieves version of PB Viewer currently available on the server.
 *     This page does not require user login
 *
 * Parameters:
 *
 *  @param cType     Type of version ('erad' - returns erad version; '' (default) returns viewer version)
 *
--%><%@
	page import="imagemed.imsession.*,imagemed.jsputil.*,imagemed.util.*,java.io.*"

%><%

	String type = request.getParameter("cType");
	if (type == null)
		type = "";

	String fname = type + "version.txt";

	response.setContentType("text/plain");
	response.setHeader("Pragma","no-cache");
	response.setHeader("Cache-Control" , "no-cache, must-revalidate");
	response.setHeader("Expiry-Date" , "Friday, 31-Dec-70 23:59:59 GMT");

	try {
		File f = new File( IMEnvBase.getEnv( "VIEWER_HOME" ) +  "/" + fname );
		long flength = f.length();

   	response.setHeader("Content-length",Long.toString(flength));
   	response.setStatus(HttpServletResponse.SC_OK);

		FileInputStream inStream = new FileInputStream(f);

		// Encoding ISO-8859-1 has the low 8 bits the same as Unicode.
		// this way bytes read by inStream are converted to char by simply
		// extending with a 0. As the output is ISO-8859-1, the same happens
		// in JspWriter's out.

		InputStreamReader in = new InputStreamReader(inStream,"ISO-8859-1");

		char[] buffer = new char[2048];
		int    size = 2048;
		int nBytes;

		while (-1 != (nBytes = in.read(buffer, 0, size))) {
			out.write(buffer,0,nBytes);
		}

		inStream.close();
		return;
	}
	catch(Throwable t1) {
		// not found or other I/O error

		response.setStatus(404);
		response.setHeader("Content-type","text/plain");
		String msg = "Not Found";
		response.setHeader("Content-length",Integer.toString(msg.length()));
		out.print(msg);
	}

%>