<%--
 ** Component: scheduler
 **
 ** Uploads an attachment and saves it in the attachment repository 
 **
 ** 	@param userfile			the Multipart containing the attachment
 **												the original filename must be xxx_1, ( or xxx_2, xxx_3, etc. in case of multiple pages)
 **   @param type					type of the entity to attach to ('order', 'patient', etc.)
 **   @param id						id of the entity to attach to (order ID, ...)
 **   @param name					name of this attachment
 **   @param savename     used for generic/admin attachments instead of name - if savename exists it means Generic or Admin document
 **                       ALSO used for uploadonly - MAY BE PROBLEM WITH NON-GENERIC UPLOAD!
 **   @param cAdmin				if intended to be an Admin document
 **		@param PACSorder		'true' if attached to a PACS order
 **		@param isUID				'true' (in case of PACS order) if id is the study UID (no scheduler order exists for the PACS order)
 **		@param cStudyIUID		the Study UID, if null, "generatedUID" will be used (usable only at PACS orders) 
 **		@param cPDF					if "true" attachment(s) will be converted to PDF (default: false)
 **		@param numpages			the number of total pages (1,2, ...) this attachment conatins
 **		@param cDocType 		the document type (display name, not inner ID!) of the attachment
 **   @param cUploadOnly  if 'true' this is an upload-only (upload button) call - savename is used
 **
 **   @return							"FILE:" + name of the uploaded file, if successful
 **
--%><%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.tomcat.Sessita"%>
<%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,imagemed.exception.*"
%><%@
	page errorPage ="../main/exceptionHandler.jsp"
%><%@page import="java.io.File"%><%@
	page import="imagemed.http.tabs.TabBean"%><%@page import="com.erad.pacs.app.broker.table.internals.TableImpl"%><%
	Sessita sessita = Sessita.Create( request, response );
	Session sess = sessita.getSession();
	

	boolean overWrite = "true".equals( request.getParameter("cOverWrite") );

	//overwrite mode akkor tud lenni, amikor browseupload.jsp-bol hivodik (vagyis nem scan, hanem file upload)
	//ilyenkor HTML-t akarunk, maskor meg nem!
	//ha !overwrite van, akkor NEM irkalunk ki mindenfelet, mert FILE: -ot var! (ha nincs hiba)
	
%><%@page import="java.util.Properties"%>
<%@page import="imagemed.scheduler.SchedulerInterface"%><%
	if( overWrite ) {
		out.println( "<HTML><HEAD><TITLE>Upload</TITLE>" );
		TabBean.writeStyleOnly( response.getWriter() );
		TableImpl.printCommonScript( response.getWriter() );
		out.println( "</HEAD><BODY>" );
	}
	else {
		response.setContentType("text/plain");
	}
//DEBUG
/*
	ServletInputStream isstream = request.getInputStream();
	File fLoginDir = new File(IMEnv.getEnv("ATTACHMENT_DATA"));
	File fVidFile = File.createTempFile(""+System.currentTimeMillis(),".sca", fLoginDir );
	FileOutputStream ostream = new FileOutputStream(fVidFile);
	byte buffer[] = new byte[2048];
	int nRead;

	while (-1 != (nRead = isstream.read(buffer))) {
				ostream.write(buffer, 0, nRead);
	}

	isstream.close();
	ostream.close();
	
	if( true )
		return;
*/	
	

	String tmpFileName;
	String type;
	String id;
	String name;
	String savename;
	String genaFileName = null;
	String numPages = null;
	String admin = "";
	boolean isPDF = false;
	String docType = null; //this will be the displayed name of the doctype!!! not the inner ID
	boolean isPACSorder = false;
	boolean isUID = false;
	String studyIUID = "";
	
	boolean isUploadedPdf = false;
	boolean isUploadOnly = false;
	
	if( !overWrite ) {
		MultipartRequest mp = new MultipartRequest( request, AttachmentManager.getTempDir() );
		tmpFileName = mp.getParameter("userfile");

		savename = mp.getParameter("savename");

		Helper.DEBUG( "SAVENAME - " + Helper.debugHex( savename ) );
		
		Helper.DEBUG( "ScanUpload", "Not Overwrite, tmpfilename:" + tmpFileName );
		isUploadOnly = "true".equals( mp.getParameter("cUploadOnly") );
		if( isUploadOnly ) {
			if( savename != null && savename.toLowerCase().endsWith( ".pdf" ) ) {
				isUploadedPdf = true;
				Helper.DEBUG( "DicomUpload", "uploadedPDF:" + savename );
			}
		}

		type = mp.getParameter("type");
		id = mp.getParameter("id");
		name = mp.getParameter("name");
		numPages = mp.getParameter("numpages");
		admin = mp.getParameter("cAdmin");
		
		Helper.DEBUG( "ScanUpload", "Numpages:" + numPages );

		genaFileName = mp.getFileNameFor("userfile");
		isPDF = "true".equals( mp.getParameter("cPDF") );
		docType = mp.getParameter("cDocType");
		isPACSorder = "true".equals( mp.getParameter("PACSorder") );
		isUID = "true".equals( mp.getParameter("isUID") );
		studyIUID = mp.getParameter( "cStudyIUID" );
	}
	else {
		tmpFileName = request.getParameter("tmpFileName");
		Helper.DEBUG( "ScanUpload", "Overwrite, tmpfilename:" + tmpFileName );
		type = request.getParameter("type");
		id = request.getParameter("id");
		name = request.getParameter("name");
		savename = request.getParameter("savename");
		admin = request.getParameter("cAdmin");
		isPDF = "true".equals( request.getParameter("cPDF") );
		docType = request.getParameter("cDocType");
		isPACSorder = "true".equals( request.getParameter("PACSorder") );
		isUID = "true".equals( request.getParameter("isUID") );
		studyIUID = request.getParameter("cStudyIUID");
		isUploadOnly = "true".equals( request.getParameter("cUploadOnly") );
	}
	
	if( docType != null ) {
		docType = AttachmentManager.getDoctypeIDFromDisplayName( docType );
	}
	
	if( savename == null ) {
		savename = "";
	}
	boolean isAdmin = "true".equals( admin );
	
	if( tmpFileName == null ) {
		if( overWrite ) {
			throw new IMException("No temporary file created in upload!");
		}
		else {
			out.println( "No temporary file created in upload!");
			return;
		}
	}

	Helper.DEBUG( "ScanUpload - BiiiBuuu", "Type:" + type + " ID:" + id + " Name:" + name + " SaveName:" + savename + " genaFileName: " + genaFileName + " numpages: " + numPages + "Doctype:" + docType + " Admin: " + admin + (isPDF ? " isPDF" : "" ) );
	
	boolean logging = AttachmentManager.isLastPage( numPages, genaFileName );
	
	Properties logFields = new Properties();
	OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "Scan/Upload" );
	Syslog operLogger = new Syslog( "upload.jsp", 0, IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );
	if( logging ) {
		logFields.setProperty( "0LAC", "Scan/Upload" );
		if( id != null ) {
			if( isPACSorder ) {
				logEntry.setField( OperLogEntry.FIELD.USER, sess.getUser().getUserId() );
				logEntry.setBasicStudyFields(sess, studyIUID );
//				OperLogEntry.makeLogFieldsFromStudyOrPACSOrder( is, studyIUID, logFields, null );
			}
			else if( "order".equals( type ) ) {
				SchedulerInterface.makeLogFieldsFromOrder( sess, id, logFields );
			}
			else if( "patient".equals( type ) ) {
				SchedulerInterface.makeLogFieldsFromPatient( sess, id, logFields );
			}
		}
	}
	
	File tmpFile = new File( tmpFileName );
	if( !tmpFile.exists() ) {
		Helper.DEBUG( "ScanUpload", "Tmp File Not Found!" );
		if( overWrite ) {
			throw new IMException("Tmp File Not Found!");
		}
		else {
			out.println( "Tmp File Not Found!");
			return;
		}
	}
	else {
		Helper.DEBUG( "ScanUpload", "Tmp File Found!" );
		if( tmpFile.length() == 0 ) {
			Helper.DEBUG( "ScanUpload", "Tmp File is empty!" );
		}
		
		if( name != null && !"".equals(name) ) {
			Helper.DEBUG( "createScanned", "type-id-name:" + name );
			
			AttachmentManager.createScanned( genaFileName, type, id, name, tmpFileName, true, false, numPages, isAdmin, isPDF, docType );
			if( "order".equals( type ) && id != null ) {
				AttachmentManager.setAttachmentCounts( id, isUID );
			}
			if( overWrite ) {
				out.println("Attachment Successfully Uploaded");
			}
			if( logging ) {
				String info = "Attachment name:" + name + " , type:" + ( isPDF ? "PDF": "JPG" ) + " , No. of pages:" + numPages;
				if( isPACSorder ) {
					logEntry.setField( OperLogEntry.FIELD.MESSAGE, info );
				}
				else {
					logFields.setProperty("0LIN", info );
				}
			}
		}
		else if( !"".equals(savename) ) {
			Helper.DEBUG( "createScanned", "with savename:" + savename );
			
			boolean isGeneric = !isAdmin;
			AttachmentManager.createScanned( genaFileName, type, id, savename, tmpFileName, true, isGeneric, numPages, isAdmin, isPDF, docType );
			if( "order".equals( type ) && id != null ) {
				AttachmentManager.setAttachmentCounts( id, isUID );
			}
			if( overWrite ) {
				out.println("Generic/Admin Attachment Successfully Uploaded");
			}
			if( logging ) {
				String info = "Generic attachment, name:" + savename + " , type:" + ( isPDF || isUploadedPdf ? "PDF": "JPG" ) + " , No. of pages:" + numPages;
				if( isPACSorder ) {
					logEntry.setField( OperLogEntry.FIELD.MESSAGE, info );
				}
				else {
					logFields.setProperty("0LIN", info );
				}
			}
		}
		else {
			Helper.DEBUG( "ScanUpload", "No name or savename found!" );
			if( overWrite ) {
				throw new IMException("No name or savename found!");
			}
			else {
				out.println( "No name or savename found!");
				return;
			}
		}
	}
	Helper.DEBUG( "ScanUpload", "before logging" );
	if( logging ) {
		if( isPACSorder ) {
			logEntry.log(sess, operLogger, Syslog.LOG_INFO );
		}
		else {
			SchedulerInterface.logIntoTable( sess, logFields );
		}
	}
	Helper.DEBUG( "ScanUpload", "after logging" );
	if( overWrite ) {
%>
<script language="JavaScript">
	window.opener.refresh(window.opener.document.saveForm, false);
	setTimeout("window.close()", 4000 );
</script>

</BODY>
</HTML>
<%
	}
	else {
		Helper.DEBUG( "upload succesful, output:'FILE:" + tmpFileName + "'" );
		out.println( "FILE:" + tmpFileName ); //means OK 
	}
%>	